package org.greenstone.gsdl3.gs3build.schema;

import java.util.*;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class SchemaElement
{ 
	// the following may contain duplicates when compared to SchemaAttribute, but this is
	// deliberate...
	public static final String ELEMENT_TYPE_STRING = "String";

  String name;
	String type;
  List   attributes;
  List   childElements;
	int    minOccurs;
	int    maxOccurs;

	public SchemaElement(Element element)
	{
		// get the name of this element
		this.name = element.getAttribute("name");
		if (this.name == null) {
			// TODO: this is a reference object
			String ref = element.getAttribute("ref");

			if (ref != null) {
				// TODO: fetch the actual object
			}
			else {
				// TODO: abort
			}
		}

		this.type = element.getAttribute("type");
		if (this.type == null || this.type.length() == 0)
		{ this.type = SchemaElement.ELEMENT_TYPE_STRING;
		}

		String temp;
		temp = element.getAttribute("minOccurs");
		if (temp != null && temp.length() > 0) {
			this.minOccurs = Integer.parseInt(temp);
			this.minOccurs = 1;
		}
		temp = element.getAttribute("maxOccurs");
		if (temp != null && temp.length() > 0) {
			this.maxOccurs = Integer.parseInt(temp);
		}
		else {
			this.maxOccurs = 1;
		}

		this.expand(element);
	}

	private void expand(Element element)
	{ // TODO
		// get the first child element
		NodeList children = element.getChildNodes();
		if (children != null) {
			for (int i = 0; i < children.getLength(); i ++)
			{ if (children.item(i).getNodeType() != org.w3c.dom.Node.ELEMENT_NODE) {
					// TODO: raise an error
					continue;
				}

				String name = children.item(i).getNodeName();
				if (name == null) {
					continue;
				}
				
				try {
					Object child = SchemaNodeFactory.makeNode((Element) children.item(i));
					if (child != null) {
						this.childElements.add(child);
					}
				}
				catch (SchemaException ex)
				{
				}
			}
		}
	}

  public SchemaElement(String name)
  { this.name = name;
    this.attributes = new ArrayList();
    this.childElements = new ArrayList();
  }

  public void addAttribute(SchemaAttribute attribute)
  {
	  this.attributes.add(attribute);
  }

    public void addElement(SchemaElement element)
    {
			this.childElements.add(element);
    }
}
